// GoCourseProject project main.go
package main

import (
	"fmt"
	"time"
)

func main() {
	bf := newBuickFactory()
	nf := newNissanFactory()

	//polymorphic
	factoryData := [...]factoryInfo{bf, nf}
	for i, _ := range factoryData {
		go fmt.Println("iteration=", i, factoryData[i].getFactoryType())
	}
	time.Sleep(time.Second * 1)
}

type factory struct {
	factoryType string
}

type buickFactory struct {
	factory
}

func newBuickFactory() *buickFactory {
	result := buickFactory{}
	result.factoryType = "Buick"
	return &result
}

func (bf buickFactory) getFactoryType() string {
	return bf.factoryType
}

type nissanFactory struct {
	factory
}

func newNissanFactory() *nissanFactory {
	result := nissanFactory{}
	result.factoryType = "Nissan"
	return &result
}

func (nf nissanFactory) getFactoryType() string {
	return nf.factoryType
}

type factoryInfo interface {
	getFactoryType() string
}
